figdir = '/home/abarth/Lectures/OCEA0036-1/Notes/Fig/';

dx = 1e3;
n = 101;
m = 2;

x = dx * [0:n-1]';

h = zeros(n,m);
p = zeros(n,m);
u = zeros(n+1,m);
hu = zeros(n+1,m);

rho = [1020 1035];

g = 9.81;
gp = (rho(2) - rho(1))/rho(1) * g;

bottom = -50 * (erf(x/(10*dx)-7) - 2 + 1.6 * exp(-(x/(10*dx)-2.2).^2 / 1^2) + x/(200*dx)) ;
%bottom = -50 * (erf(x-7) - 2 + 1.6 * exp(-(x-2.2).^2 / 1^2) + x/20) ;
bottom(:) = 100;

hm(:,1) =  bottom/2;
hm(:,2) =  bottom/2;

h(:,1) = 40 * exp(-x.^2 / (20*dx)^2) + hm(:,1);
h(:,2) = -30 * exp(-x.^2 / (20*dx)^2) + hm(:,2);

max_dt = dx/sqrt(g*max(bottom));
dt = 0.9 * max_dt;

nplot = 20;
nmax = 4000;

h_save = zeros(n,m,floor(nmax/nplot));
figure,


for i=0:nmax

  %  hu(2:end-1,:) = (h(1:end-1,:)+h(2:end,:)) .* u(2:end-1,:)/2;
  hu(2:end-1,:) = (hm(1:end-1,:)+hm(2:end,:)) .* u(2:end-1,:)/2;

  h(:,:) = h(:,:) - dt * (hu(2:end,:) - hu(1:end-1,:))/dx;

  p(:,1) = g * (sum(h,2)  - bottom);
  p(:,2) = rho(1)/rho(2) * (g * h(:,1) + (g + gp) * (h(:,2) - bottom));

  u(2:end-1,:) = u(2:end-1,:) - dt * (p(2:end,:)-p(1:end-1,:))./dx ;


  if mod(i,nplot) == 0
    i
    clf
    hold on
    z(:,m+1) = -bottom;
    plot(x,z(:,m+1))

    for k=m:-1:1
      z(:,k) = z(:,k+1) + h(:,k);
      plot(x/1e3,z(:,k))

      colormap([.5 .5 1; .4 .4 1]);
      patch([x x(end:-1:1)]/1e3,[z(:,k) z(end:-1:1,k+1)],rho(k))
      xlabel('x (km)')
      zlabel('z (m)')
    end
    
    h_save(:,:,i/nplot+1) = h;
    
    axis([min(x)/1e3 max(x)/1e3 -max(bottom) 30]);
    drawnow
    if i==6 * nplot
      %print('-deps',fullfile(figdir,'waves_snapshot.eps'));
    end

    %print('-dpng',fullfile(figdir,'Waves',sprintf('%04d.png',i/nplot)));
  end
end


figure
t = [0:nplot:nmax] * dt;
pcolor(x/1e3,t/(24*60*60),squeeze(h_save(:,2,:))')
ylabel('time (d)')
xlabel('space (km)')
colorbar
%print('-deps',fullfile(figdir,'waves_hovmoeller.eps'));
